/* Some comments.... */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#ifdef MPI
#include <mpi.h>
#endif
#ifdef THREAD
#include <pthread.h>
#endif


int fun(int argc, char** argv)
{
  int aardvark[1000];
  int *sheep;
  pid_t pid;
  pid = getpid();
  sheep = calloc(1000,1);
  memset(aardvark, -1, sizeof(int) * 1000);
  printf("./ptrace_test %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu %lu\n", 
	 pid, sheep, aardvark, &fun, sheep + 2, aardvark + 2, sheep, aardvark, &fun, sheep + 2, aardvark + 2 );
  sleep(20);
}

int main(int argc, char** argv)
{	
#ifdef THREAD
  pthread_t t1;
  pthread_t t2;

  pthread_create(&t1, NULL, (void*) &fun, "One");
  pthread_create(&t2, NULL, (void*) &fun, "Two");

  pthread_join(t1, NULL);
  pthread_join(t2, NULL);

#else
#ifdef MPI
        MPI_Init(&argc, &argv);
#endif
	fun(argc, argv);
#ifdef MPI
        MPI_Finalize();
#endif
#endif
}
